(ns clojure-x86-interpreter.memory-state)

(def machine-register-map {:rax 0
                           :rbx 0
                           :rcx 0
                           :rdx 0
                           :rsi 0
                           :rdi 0
                           :rbp 0
                           :rsp 0
                           :r8 0
                           :r9 0
                           :r10 0
                           :r11 0
                           :r12 0
                           :r13 0
                           :r14 0
                           :r15 0
                           :rip 0
                           :cs 0
                           :ds 0
                           :es 0
                           :fs 0
                           :gs 0
                           :ss 0})

(def alias-mapping {:ah :rax
                    :al :rax
                    :ax :rax
                    :eax :rax
                    :rax :rax
                    :bh :rbx
                    :bl :rbx
                    :bx :rbx
                    :ebx :rbx
                    :rbx :rbx
                    :ch :rcx
                    :cl :rcx
                    :cx :rcx
                    :ecx :rcx
                    :rcx :rcx
                    :dh :rdx
                    :dl :rdx
                    :dx :rdx
                    :edx :rdx
                    :rdx :rdx
                    :sil :rsi
                    :si :rsi
                    :esi :rsi
                    :rsi :rsi
                    :dil :rdi
                    :di :rdi
                    :edi :rdi
                    :rdi :rdi
                    :bpl :rbp
                    :bp :rbp
                    :ebp :rbp
                    :rbp :rbp
                    :spl :rsp
                    :sp :rsp
                    :esp :rsp
                    :rsp :rsp
                    :r8b :r8
                    :r8w :r8
                    :r8d :r8
                    :r8 :r8
                    :r9b :r9
                    :r9w :r9
                    :r9d :r9
                    :r9 :r9
                    :r10b :r10
                    :r10w :r10
                    :r10d :r10
                    :r10 :r10
                    :r11b :r11
                    :r11w :r11
                    :r11d :r11
                    :r11 :r11
                    :r12b :r12
                    :r12w :r12
                    :r12d :r12
                    :r12 :r12
                    :r13b :r13
                    :r13w :r13
                    :r13d :r13
                    :r13 :r13
                    :r14b :r14
                    :r14w :r14
                    :r14d :r14
                    :r14 :r14
                    :r15b :r15
                    :r15w :r15
                    :r15d :r15
                    :r15 :r15})

(def machine-flags {:cf 0
                    :pf 0
                    :af 0
                    :sf 0
                    :zf 0
                    :tf 0
                    :if 0
                    :df 0
                    :of 0})

(def memory-information {:heap-start 0
                         :heap-end 16000
                         :heap-size 16000
                         :stack-start 20000
                         :stack-end 36000
                         :stack-size 16000
                         :allocations []})

